<template>
  <q-page padding>
    <!-- content -->

    <!-- listado -->
    <div v-if="view === 'list'">
      <div class="q-pa-md">
        <q-table title="Proveedores" :rows="rows" :columns="columns" row-key="name" :no-data-label="'Sin datos'"
          :loading-label="'Cargando...'" :loading="loading" color="primary" :pagination="pagination">

          <template v-slot:top-right>
            <div class="row">
              <div class="col-9">
                <q-input dense debounce="300" v-model="filter" placeholder="Buscar...">
                  <template v-slot:append>
                    <q-icon name="search" />
                  </template>
                </q-input>
              </div>
              <div class="col-3">
                <q-btn icon="add" color="primary" @click="addProveedor()" dense round flat>
                  <q-tooltip>Agregar</q-tooltip>
                </q-btn>
              </div>
            </div>
          </template>

          <template v-slot:body="props">
            <q-tr :props="props">
              <q-td v-for="col in props.cols" :key="col.name" :props="props">
                <template v-if="col.name === 'acciones'">
                  <q-btn icon="edit" color="primary" @click="editProveedor(props.row)" dense round flat>
                    <q-tooltip>Editar</q-tooltip>
                  </q-btn>
                  <q-btn icon="delete" color="negative" @click="deleteProveedor(props.row)" dense round flat>
                    <q-tooltip>Eliminar</q-tooltip>
                  </q-btn>
                </template>
                <template v-else> {{ col.value }} </template>
              </q-td>
            </q-tr>
          </template>

        </q-table>
      </div>
    </div>

    <!-- add/edit -->
    <div v-if="view === 'add' || view === 'edit'">
      <q-form @submit="submitProveedor()">
        <q-card bordered>


          <q-card-section>
            <div class="text-h6">Agregar Proveedor</div>
            <div class="text-subtitle2">Complete los datos solicitados</div>
          </q-card-section>

          <q-card-section class="flex flex-center">
            <q-card flat bordered v-bind:style="{ 'min-width': '80%' }">
              <q-card-section>


                <div class="row">
                  <div class="col-12">
                    <q-input v-model="proveedor.nombre" label="Nombre" dense></q-input>
                  </div>
                </div>

                <div class="row q-mt-md">
                  <div class="col-12">
                    <q-input v-model="proveedor.direccion" label="Direccion" dense></q-input>
                  </div>
                </div>

                <div class="row q-mt-md">
                  <div class="col-12">
                    <q-input v-model="proveedor.telefono" label="Telefono" dense></q-input>
                  </div>
                </div>


              </q-card-section>
            </q-card>
          </q-card-section>

          <q-separator />

          <q-card-actions align="around">
            <q-btn flat color="primary" type="submit" :loading="loading">Grabar</q-btn>
            <q-btn flat @click="onCancel">Cancelar</q-btn>
          </q-card-actions>

        </q-card>
      </q-form>
    </div>

  </q-page>
</template>

<script>
import axios from 'axios'
import { onMounted, ref } from 'vue'
import { useQuasar } from 'quasar'

export default {
  // name: 'PageName',
  setup() {
    // Propiedades
    const $q = useQuasar()
    const columns = [
      { name: 'nombre', align: 'left', label: 'Nombre', field: row => row.nombre, sortable: true },
      { name: 'direccion', align: 'left', label: 'Direccion', field: row => row.direccion, sortable: true },
      { name: 'telefono', align: 'left', label: 'Telefono', field: row => row.telefono, sortable: true },
      { name: 'acciones', align: 'center', label: 'Acciones' }
    ]
    const rows = ref([])
    const view = ref('list')  //list, add, edit
    const filter = ref(null)
    const loading = ref(false)
    const proveedor = ref({})
    const pagination = ref({
      sortBy: '',
      descending: true,
      page: 1,
      rowsPerPage: 0
    })


    // Metodos
    const onRequest = () => {
      loading.value = true
      const url = 'http://localhost:5000/api/search/proveedores'
      const filtros = {}
      axios.post(url, filtros).then(res => {
        // obtener la lista de proveedores y asignar al lista para el template
        console.log(res.data.items)
        rows.value = res.data.items

      }).catch(error => {
        // emitir un mensaje
      }).finally(() => {
        // Acciones finales
        loading.value = false
      })
    }

    const clearProveedor = () => {
      return {
        id: null,
        nombre: null,
        direccion: null,
        telefono: null
      }
    }

    const addProveedor = () => {
      view.value = 'add'
      proveedor.value = clearProveedor()
    }

    const editProveedor = (instance) => {
      view.value = 'edit'
      proveedor.value = instance
    }

    const onCancel = () => {
      view.value = 'list'
      proveedor.value = clearProveedor()
    }

    const submitProveedor = () => {
      console.log(proveedor.value)
      loading.value = true

      if (proveedor.value.id) {  // Editar
        const url = `http://localhost:5000/api/proveedores/${proveedor.value.id}`
        axios.put(url, proveedor.value).then(res => {
          // notificar exito
          $q.notify({
            message: 'Proveedor Modificado',
            color: 'positive'
          })
          // redirigir a la vista de listado
          view.value = 'list'
          // actualizar el listado
          onRequest()
        }).catch(error => {
          // notificar el error
          console.log(error)
          let msg = 'Proveedor No Modificado'
          try {
            msg = error.response.data.message
          } catch (error) {
            console.log(error)
          }
          $q.notify({
            message: msg,
            color: 'negative'
          })
        }).finally(() => {
          // acciones finales
          loading.value = false
        })
      } else {  // Agregar
        const url = 'http://localhost:5000/api/proveedores'
        axios.post(url, proveedor.value).then(res => {
          // notificar exito
          $q.notify({
            message: 'Proveedor Agregado',
            color: 'positive'
          })
          // redirigir a la vista de listado
          view.value = 'list'
          // actualizar el listado
          onRequest()
        }).catch(error => {
          // notificar el error
          console.log(error)
          let msg = 'Proveedor No Agregado'
          try {
            msg = error.response.data.message
          } catch (error) {
            console.log(error)
          }
          $q.notify({
            message: msg,
            color: 'negative'
          })
        }).finally(() => {
          // acciones finales
          loading.value = false
        })
      }
    }

    const deleteProveedor = (instance) => {
      $q.dialog({
        title: 'Eliminar Proveedor',
        message: `Esta seguro de que desea eliminar el proveedor ${instance.nombre}`,
        cancel: true,
        persistent: true
      }).onOk(() => {
        // console.log('>>>> OK')
        const url = `http://localhost:5000/api/proveedores/${instance.id}`
        axios.delete(url).then(res => {
          $q.notify({
            message: 'El proveedor ha sido Borrado',
            color: 'positive'
          })
          onRequest()
        }).catch(error => {
          $q.notify({
            message: 'El proveedor No ha sido Borrado',
            color: 'negative'
          })
        })
      }).onOk(() => {
        // console.log('>>>> second OK catcher')
      }).onCancel(() => {
        // console.log('>>>> Cancel')
      }).onDismiss(() => {
        // console.log('I am triggered on both OK and Cancel')
      })
    }

    // Metodos del ciclo de vida del componente
    onMounted(() => {
      onRequest()
    })

    // Data
    return {
      columns,
      rows,
      view,
      filter,
      loading,
      proveedor,
      pagination,
      addProveedor,
      onCancel,
      submitProveedor,
      editProveedor,
      deleteProveedor
    }
  }
}
</script>
